
#property copyright " 2008.07.03 SwingMan"
#property link      ""

#property indicator_separate_window
#property indicator_levelcolor Gray
#property indicator_levelstyle 0
#property indicator_buffers 4
#property indicator_color1 MediumSeaGreen
#property indicator_color2 Tomato
#property indicator_color3 Lime
#property indicator_color4 Aqua

extern string SubSymbol = "EURUSD";
extern int nBars = 2000;
extern int Period_Ratio = 93;
extern double Factor_Threshold = 1.0;
extern string EntryTime = "";
extern string _____Order____ = "BUY=0,  SELL=1";
extern int Order_Main = -1;
extern color threshold_color = Fuchsia;
extern bool Mirroring = TRUE;
int gi_128;
string gs_132 = "NeutralHedge osc_v4";
string gs_140;
string gs_148 = "NH4_";
int g_fontsize_156 = 8;
int g_corner_160 = 1;
int gi_164 = 80;
int gi_168 = 2;
int gi_172 = 60;
int gi_176 = 30;
int gi_180 = 3;
int gi_184;
int gi_188 = 10;
double g_ibuf_192[];
double g_ibuf_196[];
double g_ibuf_200[];
double g_ibuf_204[];
double g_ibuf_208[];
double g_ibuf_212[];
double g_point_216;
int g_window_224;
int gi_unused_228;
int gi_232;

int init() {
   g_point_216 = MarketInfo(Symbol(), MODE_POINT);
   gs_140 = gs_132 + " (" + Symbol() + "-" + SubSymbol + ", " + Period_Ratio + ") ";
   IndicatorShortName(gs_140);
   IndicatorBuffers(6);
   SetIndexBuffer(0, g_ibuf_196);
   SetIndexBuffer(1, g_ibuf_192);
   SetIndexBuffer(2, g_ibuf_208);
   SetIndexBuffer(3, g_ibuf_212);
   SetIndexBuffer(4, g_ibuf_200);
   SetIndexBuffer(5, g_ibuf_204);
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexStyle(2, DRAW_ARROW, EMPTY, 1);
   SetIndexArrow(2, 159);
   SetIndexStyle(3, DRAW_ARROW, EMPTY, 1);
   SetIndexArrow(3, 159);
   SetIndexEmptyValue(0, 0.0);
   SetIndexEmptyValue(1, 0.0);
   SetIndexEmptyValue(2, 0.0);
   SetIndexEmptyValue(3, 0.0);
   SetIndexLabel(0, "BUY -" + Symbol());
   SetIndexLabel(1, "SELL-" + Symbol());
   SetIndexLabel(2, "Thresh UP");
   SetIndexLabel(3, "Thresh DN");
   IndicatorDigits(Digits);
   ArrayInitialize(g_ibuf_192, 0.0);
   ArrayInitialize(g_ibuf_196, 0.0);
   ArrayInitialize(g_ibuf_200, 0.0);
   ArrayInitialize(g_ibuf_204, 0.0);
   DeleteOwnObjects();
   g_window_224 = WindowFind(gs_140);
   return (0);
}

int deinit() {
   DeleteOwnObjects();
   return (0);
}

int start() {
   double l_high_0;
   double l_low_8;
   double ld_16;
   double ld_32;
   double ld_40;
   double ld_48;
   double ld_80;
   double ld_88;
   double ld_120;
   double l_iclose_128;
   double ld_136;
   RefreshRates();
   gi_unused_228 = Period_Ratio;
   gi_232 = Period_Ratio + 1;
   for (int li_116 = 0; li_116 < nBars; li_116++) {
      l_high_0 = High[iHighest(Symbol(), 0, MODE_HIGH, Period_Ratio, li_116)];
      l_low_8 = Low[iLowest(Symbol(), 0, MODE_LOW, Period_Ratio, li_116)];
      ld_16 = (l_high_0 + l_low_8) / 2.0;
      if (Mirroring) {
         ld_32 = iLow(SubSymbol, 0, iLowest(SubSymbol, 0, MODE_LOW, Period_Ratio, li_116));
         ld_40 = iHigh(SubSymbol, 0, iHighest(SubSymbol, 0, MODE_HIGH, Period_Ratio, li_116));
      } else {
         ld_32 = iHigh(SubSymbol, 0, iHighest(SubSymbol, 0, MODE_HIGH, Period_Ratio, li_116));
         ld_40 = iLow(SubSymbol, 0, iLowest(SubSymbol, 0, MODE_LOW, Period_Ratio, li_116));
      }
      ld_48 = (ld_32 + ld_40) / 2.0;
      ld_88 = (l_high_0 - l_low_8) / (ld_32 - ld_40);
      ld_80 = iClose(SubSymbol, 0, li_116) - ld_48;
      ld_120 = ld_16 + ld_80 * ld_88;
      l_iclose_128 = iClose(Symbol(), 0, li_116);
      ld_136 = (l_iclose_128 - ld_120) / g_point_216;
      if (ld_136 > 0.0) g_ibuf_192[li_116] = ld_136;
      else g_ibuf_196[li_116] = ld_136;
      for (int li_112 = li_116; li_112 < li_116 + gi_232; li_112++) {
         ld_80 = iClose(SubSymbol, 0, li_112) - ld_48;
         ld_120 = ld_16 + ld_80 * ld_88;
         l_iclose_128 = iClose(Symbol(), 0, li_112);
         ld_136 = (l_iclose_128 - ld_120) / g_point_216;
         if (ld_136 > 0.0) g_ibuf_200[li_112] = ld_136;
         else g_ibuf_204[li_112] = ld_136;
      }
     Get_ThresholdValue(li_116);
      g_ibuf_208[li_116] = gi_128;
      g_ibuf_212[li_116] = -gi_128;
   }
   Write_WinLossTrading();
   return (0);
}

void Get_ThresholdValue(int ai_0) {
   double lda_4[1000];
   ArraySetAsSeries(lda_4, TRUE);
   int l_period_8 = Period_Ratio;
   int li_12 = -1;
   for (int li_16 = ai_0; li_16 < ai_0 + gi_232; li_16++) {
      li_12++;
      if (g_ibuf_200[li_16] != 0.0 && g_ibuf_200[li_16] != EMPTY_VALUE) lda_4[li_12] = MathAbs(g_ibuf_200[li_16]);
      else
         if (g_ibuf_204[li_16] != 0.0 && g_ibuf_204[li_16] != EMPTY_VALUE) lda_4[li_12] = MathAbs(g_ibuf_204[li_16]);
   }
   double l_ima_on_arr_20 = iMAOnArray(lda_4, 0, l_period_8, 1, MODE_SMA, 0);
   double l_istddev_on_arr_28 = iStdDevOnArray(lda_4, 0, l_period_8, 1, MODE_SMA, 0);
   gi_128 = l_ima_on_arr_20 + Factor_Threshold * l_istddev_on_arr_28;
}

void Write_WinLossTrading() {
   double ld_0;
   string ls_8;
   string ls_16;
   string ls_24;
   string ls_32;
   int l_shift_40;
   double l_iclose_44;
   double l_iclose_52;
   double l_iclose_60;
   double l_iclose_68;
   int li_76;
   if (EntryTime != "") {
      gi_184 = gi_180;
      l_shift_40 = iBarShift(Symbol(), 0, StrToTime(EntryTime), TRUE);
      l_iclose_44 = iClose(Symbol(), 0, l_shift_40);
      l_iclose_52 = iClose(SubSymbol, 0, l_shift_40);
      l_iclose_60 = iClose(Symbol(), 0, 0);
      l_iclose_68 = iClose(SubSymbol, 0, 0);
      ld_0 = 0;
      if (Order_Main == 0) {
         ld_0 = l_iclose_60 - l_iclose_44 + (l_iclose_52 - l_iclose_68);
         ls_24 = Symbol() + "-BUY:";
      } else {
         if (Order_Main == 1) {
            ld_0 = -(l_iclose_60 - l_iclose_44) - (l_iclose_52 - l_iclose_68);
            ls_24 = Symbol() + "-SELL:";
         } else {
            l_iclose_44 = 0;
            l_iclose_52 = 0;
            ls_24 = "Order_Main:";
            ls_32 = "EMPTY";
         }
      }
      ld_0 /= g_point_216;
      ls_8 = "Entry time:";
      ls_16 = EntryTime;
      Write_Label(ls_8, ls_16, gi_164 + 10, gi_168, gi_184);
      gi_184 += gi_188;
      ls_8 = ls_24;
      if (ls_24 == "Order_Main:") {
         ls_16 = ls_32;
         li_76 = gi_176;
      } else {
         ls_16 = DoubleToStr(l_iclose_44, Digits) + " / " + DoubleToStr(l_iclose_52, Digits);
         li_76 = gi_168;
      }
      Write_Label(ls_8, ls_16, gi_164, li_76, gi_184);
      gi_184 += gi_188;
      ls_8 = "Current price:";
      ls_16 = DoubleToStr(l_iclose_60, Digits) + " / " + DoubleToStr(l_iclose_68, Digits);
      Write_Label(ls_8, ls_16, gi_164, gi_168, gi_184);
      gi_184 += gi_188;
      ls_8 = "WinLoss:";
      ls_16 = DoubleToStr(ld_0, 0);
      Write_Label(ls_8, ls_16, gi_164, gi_172, gi_184);
      gi_184 += gi_188;
   }
}

void Write_Label(string as_0, string as_8, int ai_16, int ai_20, int ai_24) {
   int li_28 = 42495;
   string ls_32 = gs_148 + "1" + ai_24;
   string ls_40 = gs_148 + "2" + ai_24;
   SetLabelObject(ls_32, as_0, li_28, ai_16, ai_24);
   SetLabelObject(ls_40, as_8, li_28, ai_20, ai_24);
}

void SetLabelObject(string a_name_0, string a_text_8, color a_color_16, int a_x_20, int a_y_24) {
   ObjectCreate(a_name_0, OBJ_LABEL, g_window_224, 0, 0);
   ObjectSetText(a_name_0, a_text_8, g_fontsize_156, "Arial Bold", a_color_16);
   ObjectSet(a_name_0, OBJPROP_CORNER, g_corner_160);
   ObjectSet(a_name_0, OBJPROP_XDISTANCE, a_x_20);
   ObjectSet(a_name_0, OBJPROP_YDISTANCE, a_y_24);
}

void DeleteOwnObjects() {
   int li_0 = 0;
   while (li_0 <= ObjectsTotal()) {
      if (StringFind(ObjectName(li_0), gs_148) >= 0) ObjectDelete(ObjectName(li_0));
      else li_0++;
   }
}